<?php

namespace Drupal\mail_box_management\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\mail_box_management\Form\ConfigurationForm;
use Drupal\mail_box_management\Plugin\ThemeTemplateLoader;

/**
 *
 */
class MailboxManagement extends ControllerBase {

  private ThemeTemplateLoader $themeTemplateLoader;

  public function __construct() {
    $this->themeTemplateLoader = mail_box_management_service('mail_box_management.theme');
  }

  /**
   * @throws \Exception
   */
  public function configuration(): array {
    $template = 'mail-box-management-configuration';
    $form = $this->formBuilder()->getForm(ConfigurationForm::class);
    return [
      '#markup' => $this->themeTemplateLoader->getThemeTemplateContent($template, ['form' => $form]),
      '#attached' => [
        'library' => [
          'assets_management',
        ],
      ],
    ];
  }

}
