<?php
namespace Drupal\mail_box_management\Server\Imap;

use IMAP\Connection;
use Drupal\Core\Config\Config;
use Symfony\Component\HttpFoundation\RedirectResponse;

/**
 *
 */
class ImapConnection {

  public Config $configUsername;
  public Config $configPassword;
  public Config $configHostname;
  public Config $configPort;
  public false|Connection $imap_connection;

  public Config $secure;

  public string $hostname;

  public function __construct() {
    $config_helper = mail_box_management_service('mail_box_management.config');
    $this->configHostname = $config_helper->get('mail_box_management.imap_server_host');
    $this->configUsername = $config_helper->get('mail_box_management.imap_server_user_name');
    $this->configPassword = $config_helper->get('mail_box_management.imap_server_password');
    $this->configPort = $config_helper->get('mail_box_management.imap_server_port');
    $this->secure = $config_helper->get('mail_box_management.imap_server_secure');

    if (!empty($this->configHostname->get('imap_server_host')) &&
      !empty($this->configPort->get('imap_server_port')) &&
      !empty($this->configUsername->get('imap_server_user_name')) &&
      !empty($this->configPassword->get('imap_server_password')) &&
      !empty($this->secure->get('imap_server_secure'))
    ) {
      $this->hostname = "{{$this->configHostname->get('imap_server_host')}:{$this->configPort->get('imap_server_port')}/imap/{$this->secure->get('imap_server_secure')}}";
      $this->imap_connection = imap_open($this->hostname, $this->configUsername->get('imap_server_user_name'), $this->configPassword->get('imap_server_password'));
    }

  }

  /**
   *
   */
  public function __destruct() {
    unset($this->imap_connection);
  }

}
